> ## Documentation Index
> Fetch the complete documentation index at: https://docs.vellaro.io/llms.txt
> Use this file to discover all available pages before exploring further.

# Get Product

> Public single product detail by slug.



## OpenAPI

````yaml https://api.vellaro.io/openapi.json get /api/v1/products/{slug}
openapi: 3.1.0
info:
  title: Vellaro API
  description: Vellaro 2026 — E-commerce API
  version: 0.1.0
servers:
  - url: https://api.vellaro.io
    description: Produzione
security: []
tags: []
paths:
  /api/v1/products/{slug}:
    get:
      tags:
        - products
      summary: Get Product
      description: Public single product detail by slug.
      operationId: get_product_api_v1_products__slug__get
      parameters:
        - name: slug
          in: path
          required: true
          schema:
            type: string
            title: Slug
        - name: lang
          in: query
          required: false
          schema:
            anyOf:
              - type: string
              - type: 'null'
            description: Force content language (it|en|sq)
            title: Lang
          description: Force content language (it|en|sq)
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiResponse_ProductOut_'
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
components:
  schemas:
    ApiResponse_ProductOut_:
      properties:
        data:
          anyOf:
            - $ref: '#/components/schemas/ProductOut'
            - type: 'null'
        meta:
          anyOf:
            - $ref: '#/components/schemas/PaginationMeta'
            - type: 'null'
        error:
          anyOf:
            - type: string
            - type: 'null'
          title: Error
        error_code:
          anyOf:
            - type: string
            - type: 'null'
          title: Error Code
      type: object
      title: ApiResponse[ProductOut]
    HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/ValidationError'
          type: array
          title: Detail
      type: object
      title: HTTPValidationError
    ProductOut:
      properties:
        id:
          type: string
          format: uuid
          title: Id
        name:
          type: string
          title: Name
        slug:
          type: string
          title: Slug
        description:
          anyOf:
            - type: string
            - type: 'null'
          title: Description
        short_description:
          anyOf:
            - type: string
            - type: 'null'
          title: Short Description
        name_i18n:
          anyOf:
            - additionalProperties: true
              type: object
            - type: 'null'
          title: Name I18N
        description_i18n:
          anyOf:
            - additionalProperties: true
              type: object
            - type: 'null'
          title: Description I18N
        short_description_i18n:
          anyOf:
            - additionalProperties: true
              type: object
            - type: 'null'
          title: Short Description I18N
        meta_title_i18n:
          anyOf:
            - additionalProperties: true
              type: object
            - type: 'null'
          title: Meta Title I18N
        meta_description_i18n:
          anyOf:
            - additionalProperties: true
              type: object
            - type: 'null'
          title: Meta Description I18N
        category_id:
          anyOf:
            - type: string
              format: uuid
            - type: 'null'
          title: Category Id
        brand_id:
          anyOf:
            - type: string
              format: uuid
            - type: 'null'
          title: Brand Id
        model_number:
          anyOf:
            - type: string
            - type: 'null'
          title: Model Number
        upc:
          anyOf:
            - type: string
            - type: 'null'
          title: Upc
        ean:
          anyOf:
            - type: string
            - type: 'null'
          title: Ean
        mpn:
          anyOf:
            - type: string
            - type: 'null'
          title: Mpn
        weight_kg:
          anyOf:
            - type: string
              pattern: ^(?!^[-+.]*$)[+-]?0*\d*\.?\d*$
            - type: 'null'
          title: Weight Kg
        length_cm:
          anyOf:
            - type: string
              pattern: ^(?!^[-+.]*$)[+-]?0*\d*\.?\d*$
            - type: 'null'
          title: Length Cm
        width_cm:
          anyOf:
            - type: string
              pattern: ^(?!^[-+.]*$)[+-]?0*\d*\.?\d*$
            - type: 'null'
          title: Width Cm
        height_cm:
          anyOf:
            - type: string
              pattern: ^(?!^[-+.]*$)[+-]?0*\d*\.?\d*$
            - type: 'null'
          title: Height Cm
        minimum_quantity:
          type: integer
          title: Minimum Quantity
        sort_order:
          type: integer
          title: Sort Order
        view_count:
          type: integer
          title: View Count
        is_featured:
          type: boolean
          title: Is Featured
        available_at:
          anyOf:
            - type: string
              format: date
            - type: 'null'
          title: Available At
        is_active:
          type: boolean
          title: Is Active
        meta_title:
          anyOf:
            - type: string
            - type: 'null'
          title: Meta Title
        meta_description:
          anyOf:
            - type: string
            - type: 'null'
          title: Meta Description
        shipping:
          type: boolean
          title: Shipping
        subtract:
          type: boolean
          title: Subtract
        is_digital:
          type: boolean
          title: Is Digital
          default: false
        points:
          type: integer
          title: Points
        jan:
          anyOf:
            - type: string
            - type: 'null'
          title: Jan
        isbn:
          anyOf:
            - type: string
            - type: 'null'
          title: Isbn
        location:
          anyOf:
            - type: string
            - type: 'null'
          title: Location
        stock_status_id:
          anyOf:
            - type: string
            - type: 'null'
          title: Stock Status Id
        tax_class_id:
          anyOf:
            - type: string
            - type: 'null'
          title: Tax Class Id
        weight_class_id:
          anyOf:
            - type: string
            - type: 'null'
          title: Weight Class Id
        length_class_id:
          anyOf:
            - type: string
            - type: 'null'
          title: Length Class Id
        created_at:
          type: string
          format: date-time
          title: Created At
        updated_at:
          type: string
          format: date-time
          title: Updated At
        brand:
          anyOf:
            - $ref: '#/components/schemas/BrandOut'
            - type: 'null'
        variants:
          items:
            $ref: '#/components/schemas/ProductVariantOut'
          type: array
          title: Variants
          default: []
        images:
          items:
            $ref: '#/components/schemas/ProductImageOut'
          type: array
          title: Images
          default: []
        option_groups:
          items:
            $ref: '#/components/schemas/ProductOptionOut'
          type: array
          title: Option Groups
          default: []
        recurrings:
          items:
            $ref: '#/components/schemas/RecurringPlanOut'
          type: array
          title: Recurrings
          default: []
      type: object
      required:
        - id
        - name
        - slug
        - description
        - short_description
        - category_id
        - brand_id
        - model_number
        - upc
        - ean
        - mpn
        - weight_kg
        - length_cm
        - width_cm
        - height_cm
        - minimum_quantity
        - sort_order
        - view_count
        - is_featured
        - available_at
        - is_active
        - meta_title
        - meta_description
        - shipping
        - subtract
        - points
        - jan
        - isbn
        - location
        - stock_status_id
        - tax_class_id
        - weight_class_id
        - length_class_id
        - created_at
        - updated_at
      title: ProductOut
    PaginationMeta:
      properties:
        page:
          type: integer
          title: Page
        page_size:
          type: integer
          title: Page Size
        total:
          type: integer
          title: Total
        total_pages:
          type: integer
          title: Total Pages
      type: object
      required:
        - page
        - page_size
        - total
        - total_pages
      title: PaginationMeta
    ValidationError:
      properties:
        loc:
          items:
            anyOf:
              - type: string
              - type: integer
          type: array
          title: Location
        msg:
          type: string
          title: Message
        type:
          type: string
          title: Error Type
        input:
          title: Input
        ctx:
          type: object
          title: Context
      type: object
      required:
        - loc
        - msg
        - type
      title: ValidationError
    BrandOut:
      properties:
        id:
          type: string
          format: uuid
          title: Id
        name:
          type: string
          title: Name
        name_i18n:
          anyOf:
            - additionalProperties: true
              type: object
            - type: 'null'
          title: Name I18N
        slug:
          type: string
          title: Slug
        image_url:
          anyOf:
            - type: string
            - type: 'null'
          title: Image Url
        sort_order:
          type: integer
          title: Sort Order
        is_active:
          type: boolean
          title: Is Active
      type: object
      required:
        - id
        - name
        - slug
        - image_url
        - sort_order
        - is_active
      title: BrandOut
    ProductVariantOut:
      properties:
        id:
          type: string
          format: uuid
          title: Id
        sku:
          type: string
          title: Sku
        name:
          anyOf:
            - type: string
            - type: 'null'
          title: Name
        price:
          type: string
          pattern: ^(?!^[-+.]*$)[+-]?0*\d*\.?\d*$
          title: Price
        compare_at_price:
          anyOf:
            - type: string
              pattern: ^(?!^[-+.]*$)[+-]?0*\d*\.?\d*$
            - type: 'null'
          title: Compare At Price
        sale_price:
          anyOf:
            - type: string
              pattern: ^(?!^[-+.]*$)[+-]?0*\d*\.?\d*$
            - type: 'null'
          title: Sale Price
        sale_start:
          anyOf:
            - type: string
              format: date-time
            - type: 'null'
          title: Sale Start
        sale_end:
          anyOf:
            - type: string
              format: date-time
            - type: 'null'
          title: Sale End
        stock:
          type: integer
          title: Stock
        track_inventory:
          type: boolean
          title: Track Inventory
        allow_backorder:
          type: boolean
          title: Allow Backorder
        weight:
          anyOf:
            - type: string
              pattern: ^(?!^[-+.]*$)[+-]?0*\d*\.?\d*$
            - type: 'null'
          title: Weight
        barcode:
          anyOf:
            - type: string
            - type: 'null'
          title: Barcode
        attributes:
          anyOf:
            - additionalProperties: true
              type: object
            - type: 'null'
          title: Attributes
        is_active:
          type: boolean
          title: Is Active
        created_at:
          type: string
          format: date-time
          title: Created At
      type: object
      required:
        - id
        - sku
        - name
        - price
        - compare_at_price
        - sale_price
        - sale_start
        - sale_end
        - stock
        - track_inventory
        - allow_backorder
        - weight
        - barcode
        - attributes
        - is_active
        - created_at
      title: ProductVariantOut
    ProductImageOut:
      properties:
        id:
          type: string
          format: uuid
          title: Id
        url:
          type: string
          title: Url
        alt:
          anyOf:
            - type: string
            - type: 'null'
          title: Alt
        position:
          type: integer
          title: Position
        is_primary:
          type: boolean
          title: Is Primary
      type: object
      required:
        - id
        - url
        - alt
        - position
        - is_primary
      title: ProductImageOut
    ProductOptionOut:
      properties:
        product_option_id:
          type: string
          format: uuid
          title: Product Option Id
        option_id:
          type: string
          format: uuid
          title: Option Id
        name:
          anyOf:
            - type: string
            - type: 'null'
          title: Name
        type:
          anyOf:
            - type: string
            - type: 'null'
          title: Type
        required:
          type: boolean
          title: Required
          default: true
        values:
          items:
            $ref: '#/components/schemas/ProductOptionValueOut'
          type: array
          title: Values
          default: []
      type: object
      required:
        - product_option_id
        - option_id
      title: ProductOptionOut
    RecurringPlanOut:
      properties:
        id:
          type: string
          format: uuid
          title: Id
        name_i18n:
          anyOf:
            - additionalProperties: true
              type: object
            - type: 'null'
          title: Name I18N
        price:
          type: string
          pattern: ^(?!^[-+.]*$)[+-]?0*\d*\.?\d*$
          title: Price
        frequency:
          type: string
          title: Frequency
        duration:
          type: integer
          title: Duration
        cycle:
          type: integer
          title: Cycle
        trial_status:
          type: boolean
          title: Trial Status
          default: false
        trial_price:
          anyOf:
            - type: string
              pattern: ^(?!^[-+.]*$)[+-]?0*\d*\.?\d*$
            - type: 'null'
          title: Trial Price
        trial_frequency:
          anyOf:
            - type: string
            - type: 'null'
          title: Trial Frequency
        trial_duration:
          anyOf:
            - type: integer
            - type: 'null'
          title: Trial Duration
        trial_cycle:
          anyOf:
            - type: integer
            - type: 'null'
          title: Trial Cycle
      type: object
      required:
        - id
        - price
        - frequency
        - duration
        - cycle
      title: RecurringPlanOut
      description: Public recurring plan attached to a product (R17 storefront exposure).
    ProductOptionValueOut:
      properties:
        option_value_id:
          type: string
          format: uuid
          title: Option Value Id
        name:
          anyOf:
            - type: string
            - type: 'null'
          title: Name
        color:
          anyOf:
            - type: string
            - type: 'null'
          title: Color
        price:
          type: string
          pattern: ^(?!^[-+.]*$)[+-]?0*\d*\.?\d*$
          title: Price
          default: '0'
        price_prefix:
          type: string
          title: Price Prefix
          default: +
      type: object
      required:
        - option_value_id
      title: ProductOptionValueOut
      description: One option value enabled for a product (with optional price modifier).

````